package UI.GameState;


import UI.MyListener;

import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;

public class BulletState  {

    public int locX, locY, diam , angle;
    private WallState wallState;
    private boolean keySpace;
    private KeyHandler2 keyHandler2 = new KeyHandler2();
    private long createTime;


    public BulletState(WallState wallState , TankState tankState){
        this.wallState = wallState ;
        // Initialize the game state and all elements ...
        locX = tankState.locX;
        locY = tankState.locY;
        angle = tankState.rotate;
        diam = 10;
        keySpace = false;
        tankState.getMyListener().add(keyHandler2);
        createTime = System.currentTimeMillis();
    }

    public void update(){
            locY += 10*Math.sin(Math.toRadians(angle) ) ;
            locX += 10*Math.cos(Math.toRadians(angle) ) ;
    }


    public long getCreateTime() {
        return createTime;
    }

    class KeyHandler2 extends KeyAdapter{
        @Override
        public void keyPressed(KeyEvent e){
            if (e.getKeyCode() == KeyEvent.VK_SPACE) {
                keySpace = true;
            }
        }

        @Override
        public void keyReleased(KeyEvent e){
            if (e.getKeyCode() == KeyEvent.VK_SPACE) {
                keySpace = false;
            }
        }

    }

}
